;;
;;  TOPPERS Software
;;      Toyohashi Open Platform for Embedded Real-Time Systems
;; 
;;  Copyright (C) 2010 by TAKUYA
;;              Embedded and Real-Time Systems Laboratory
;;              Graduate School of Information Science, Nagoya Univ., JAPAN
;; 
;;  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
;;  Ai{\tgEFAς̂܂ށDȉjgpEE
;;  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
;;  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
;;      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
;;      XR[hɊ܂܂Ă邱ƁD
;;  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
;;      pł`ōĔzzꍇɂ́CĔzzɔhLgip
;;      ҃}jAȂǁjɁCL̒쌠\C̗pщL
;;      ̖ۏ؋Kfڂ邱ƁD
;;  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
;;      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
;;      ƁD
;;    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
;;        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
;;    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
;;        񍐂邱ƁD
;;  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
;;      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
;;      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
;;      RɊÂCL쌠҂TOPPERSvWFNg
;;      Ɛӂ邱ƁD
;; 
;;  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
;;  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
;;  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
;;  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
;;  ̐ӔC𕉂ȂD
;; 
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  tf-mode for xyzzy
;;
;;
;;  [h@D
;;  1. tf-mode.l  site-lisp/ ̉ɁC
;;     tf  etc/ ̉ɂꂼꂨD
;;  2. L .xyzzy ɒǉD
;;  
;; (require "tf-mode")
;; (push '("\\.tf$" . tf-mode) *auto-mode-alist*)
;;

(provide "tf-mode")

(in-package "editor")

(export '(tf-mode
         *tf-mode-hook* *tf-indent-column*
	 *tf-tab-always-indent*))

(defvar *tf-mode-hook* nil)

;; (add-hook '*tf-mode-hook* #'(lambda()
;;   (set-syntax-match (syntax-table) #\( #\))
;;   (set-syntax-match (syntax-table) #\{ #\})
;;   (set-syntax-match (syntax-table) #\[ #\])
;; ))

(defvar *tf-mode-map* nil)
(unless *tf-mode-map*
  (setq *tf-mode-map* (make-sparse-keymap))
  (define-key *tf-mode-map* #\TAB 'tf-indent-line)
  )

(defvar *tf-mode-syntax-table* nil)
(unless *tf-mode-syntax-table*
  (setq *tf-mode-syntax-table* (make-syntax-table)))
;;  (set-syntax-start-comment *tf-mode-syntax-table* #\$\t t)
;;  (set-syntax-end-comment *tf-mode-syntax-table* #\LFD nil t))


;; etc/tf̃L[[hQ

(defvar *tf-keyword-hash-table* nil)
(defvar *tf-keyword-file* "tf")

;; FÂL[[h

(defvar *tf-regexp-keyword-list* nil)
(setq *tf-regexp-keyword-list*
     (compile-regexp-keyword-list
      '(
	 ("^\$[ \t].*" nil (:keyword :comment :line) nil nil nil)
	 ("\\([\$]\\)\\(IF\\|FOREACH\\|JOINEACH\\)\\([ \t]\\)" nil (:keyword 0 :bold) nil 2 nil)
	 ("\\([\$]\\)\\(END\\|ELSE\\)\\([\$]\\)" nil (:keyword 0 :bold) nil 2 2)
	 ("\\([\$]\\)\\(FUNCTION\\|FILE\\|INCLUDE\\)\\([ \t]\\)" nil (:keyword 1 :bold) nil 2 nil)
	 ("\\([\$]\\)\\(ERROR\\|WORNING\\)\\([ \t\$]\\)" nil (:keyword 1 :bold) nil 2 2)
	 ("\\([\$]\\)\\(SPC\\|TAB\\|NL\\|ARGC\\|ARGV\\|RESULT\\)\\([\$]\\)" nil (:keyword :string :bold) nil 2 2)
	 ("\\([\"]\\)\\([^\"]\\)*\\([\"]\\)" nil (:keyword :string) nil nil nil)
	 ("\\([\']\\)\\([^\']\\)*\\([\']\\)" nil (:keyword :string) nil nil nil)
	)
      ))
;	("K\" 啶̋ʂȂH color L͈ ǂ ǂ܂)


;;--------------------------------------------------------------------------
;;
;;  CfgɊւ`
;;
;;--------------------------------------------------------------------------

(defvar *tf-tab-always-indent* t)

(defvar *tf-block-beg-re*
  "[\$]\\(IF\\|FOREACH\\|JOINEACH\\|FUNCTION\\)[ ]")
(defvar *tf-block-mid-re*
  "\$ELSE[\$]")
(defvar *tf-block-end-re* "\$END[\$]")

(defvar *tf-indent-column* 4)

(defun tf-space-line ()
  "sǂ"
  (save-excursion
    (goto-bol)
    (looking-at "\\([ \t]*$\\|^\$[ \t]\\)")))

(defun tf-previous-line ()
  "sȂs܂Ŗ߂"
  (while (forward-line -1)
    ;(message-box (format nil "=> ~D" (current-line-number)))
    (unless (tf-space-line)
	(return-from tf-previous-line t))))

(defun calc-tf-indent ()
  "Cfg鐔𐔂"
  (let ((column 0) (curp (point)))
    (save-excursion
      ;O̍s𒲂ׂ
      (when (tf-previous-line)
	(goto-bol)
	(skip-chars-forward " \t")
	; Cfg
	(setq column (current-column))
	;(message-box (format nil "column1: ~D" column))
	(save-restriction
	  (narrow-to-region (progn (goto-eol) (point))
			    (progn (goto-bol) (point)))
	  (skip-chars-forward " \t")
	  ; Ĵ΃Cfg𑝂₷
	  (cond
	   ((looking-at *tf-block-beg-re*)
	    (setq column (+ column *tf-indent-column*)))
	   ((looking-at *tf-block-mid-re*)
	    (setq column (+ column *tf-indent-column*)))
	  )
	)))
    ;(message-box (format nil "column2: ~D" column))
    ; ݂̍s𒲂ׂ
    (save-excursion
      (save-restriction
	(narrow-to-region (progn (goto-eol) (point))
			  (progn (goto-bol) (point)))
	(goto-bol)
	(skip-chars-forward " \t")
	; ̂΃Cfg炷
	(cond
	 ((looking-at *tf-block-end-re*)
	  (setq column (- column *tf-indent-column*)))
	 ((looking-at *tf-block-mid-re*)
	  (setq column (- column *tf-indent-column*)))
	)))
    column
  ))

(defun tf-not-comment-line ()
  (save-excursion
    (progn
      (beginning-of-line)
      (if (looking-at "^\$[ \t]")
	  nil
	  t
	  )
      )
    ))

(defun tf-indent-line ()
  (interactive "*")
  (if (or (not (interactive-p))
	  *tf-tab-always-indent*
	  (save-excursion
	    (skip-chars-backward " \t")
	    (bolp)))
    (if (tf-not-comment-line) ;; RgsłȂΎs
      ; ς
      (let ((column (calc-tf-indent)))
	(when (integerp column)
	  (save-excursion
	    (goto-bol)
	    (delete-region (point)
			   (progn
			     (skip-chars-forward " \t")
			     (point)))
	    (indent-to column)))
	(if (and (bolp) column)
	    (skip-chars-forward " \t")))
	 )
    (insert "\t"))
  t)

;; -------------------------------------------------------------------------
;;
;;  tf-mode{
;;
;; -------------------------------------------------------------------------

(defun tf-mode ()
 (interactive)
 (kill-all-local-variables)
 (setq buffer-mode 'tf-mode)
 (setq mode-name "tf")
 (use-keymap *tf-mode-map*)
 (make-local-variable 'mode-specific-indent-command)
 (setq mode-specific-indent-command #'tf-indent-line)
 (use-syntax-table *tf-mode-syntax-table*)
 (and *tf-keyword-file*
    (null *tf-keyword-hash-table*)
    (setq *tf-keyword-hash-table*
      (load-keyword-file *tf-keyword-file*)))
 (when *tf-keyword-hash-table*
    (make-local-variable 'keyword-hash-table)
    (setq keyword-hash-table *tf-keyword-hash-table*))
 (make-local-variable 'regexp-keyword-list)
 (setq regexp-keyword-list *tf-regexp-keyword-list*)
 (run-hooks '*tf-mode-hook*))

;; -------------------------------------------------------------------------
;;
;;  $END$̑ΉT
;;
;; -------------------------------------------------------------------------

;; ΉT߂̐K\
(defvar *tf-block-keyword* "[\$]\\(IF[ \t]\\|FOREACH[ \t]\\|JOINEACH[ \t]\\|FUNCTION[ \t]\\|END[\$]\\)")
(defvar *tf-block-tag* 'tf-block)


(defvar-local *stored-text-attributes* nil)

(defun save-text-attributes (&optional start end)
  (setq *stored-text-attributes*
        (list-text-attributes start end)))

(defun restore-text-attributes ()
  (mapc (lambda (attr) (apply #'set-text-attribute attr))
        *stored-text-attributes*)
  (setq *stored-text-attributes* nil))


(defun tf-block-pre-hook ()
  (delete-text-attributes *tf-block-tag*)
  (restore-text-attributes)
  )


(defun tf-block-hook ()
  (progn
    (if (string-match "tf" mode-name) ;; tf-modêƂ
	(let (now)
	  (save-excursion
	    (progn
	      (setq now (point))
	      (if (string-match "\$END\$" (buffer-substring (- now 5) (- now 1))) ;; $END$̌ɃJ[\
		  (progn
		    (goto-char now)
		    (save-text-attributes)
		    (do-tf-block) ;; {̌Ăяo
		    )
		)
	      )
	    )
	  )
      )
    )
  )

(defun do-tf-block ()
  (let (from to end_depth line_no line_string tmp_string now)
    (save-excursion
      (setq from (point))
      (backward-char 1)
      (if (scan-buffer *tf-block-keyword* :reverse t :regexp t)
	  (progn
	    (setq end_depth 1) ;; $END$̐[
	    (while (> end_depth 0) ;; $END$̑Ή܂
	      (progn
		(if (scan-buffer *tf-block-keyword* :reverse t :regexp t :no-dup t)
		    (progn
		      (setq tmp_string (match-string 0))
		      (setq now (point))
		      (beginning-of-line)
		      (if (not (string-match "^$[ \t]" (buffer-substring (point) (+ (point) 2)))) ;; RgAEg`FbN
			  (progn
			    (goto-char now)
			    (if (string-match "[\$]END[\$]" tmp_string) ;; $END$
				 (setq end_depth (+ end_depth 1)) ;; [+1
			      (progn ;; $END$ȊO
			  	 (setq end_depth (- end_depth 1)) ;; [-1
				  ))
			    )
			)
		      )
		  (setq end_depth -1) ;; $END$̑ΉȂ
		  )))
	    (if (= end_depth 0) ;; $END$̑Ή
		(progn
		  (setq to (point))
		  (setq line_no (current-line-number))
		  (end-of-line)
		  (setq line_string (buffer-substring to (point)))
		  (message "~d : ~s" line_no line_string) ;; sԍ,se\
		  (set-text-attribute from to *tf-block-tag* :bold t) ;; ͂܂ꂽ͈͂
		  )
	      (message "Ȃ") ;; $END$̑ΉȂ
	      )
	    )
	)
      )
    )
  )


(add-hook '*pre-command-hook* 'tf-block-pre-hook) ;; post-command-hookɒǉ
(add-hook '*post-command-hook* 'tf-block-hook) ;; post-command-hookɒǉ
